//+------------------------------------------------------------------+ 
//|   TRO_Multi_Meter_FractalDimension                               | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


/*

http://www.fractalmarketreport.com/fmr-faq.php

 	
Practically speaking, the most helpful thing about the fractal dimension is it gives us some idea what a chart is going 
to do next. This comes from the key observation that markets move in a steady rhythm between trend and congestion.

Understanding and watching the progression of this rhythm, using the fractal dimension to quantify it, 
can give us a good idea what a market is likely to do next.
If a market has been in a long period of congestion -- with a high reading on the fractal dimension -- 
then we can assume that the next major move will be a trend. We can also use the fractal dimension to recognize 
when the market is "self-organizing" itself into a trend, which is the way a market evolves and 
adapts to new energy (money) coming into or out of the system. 
When the fractal dimension moves from high levels down through 55, we have a good idea that a trend is starting, 
and that it will likely continue down towards the 30 area, where trends tend to lose energy and stop.

Conversely, when a trend has reached a fractal dimension reading of 30, 
we have a pretty good idea that the trend has run its course, 
and a consolidation or retracement is now about to unfold. 
The fractal dimension readings then move up during congestion periods.

Of course, there are always exceptions and outliers, but those can be cataloged too. 
A financial market always needs to be approached with the mindset that we can never know exactly what it will do, 
but we can have a pretty good idea about how it will adapt and evolve, greatly increasing the likelihood of success.



*/

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_chart_window

extern bool Show_Heading = true;

 
extern string IndName = "FRACD" ; // change

extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int Shift_UP_DN = 65; 
extern int Adjust_Side_to_side  = 20; // 20

extern color BarLabel_color     = DarkGray;
extern color CommentLabel_color = DarkGray;


string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

int tm;
int    MAMode;

string strMAType;
string LabelTime="";

double   FRACTALS0, FRACTALS1 ;  
 
   string IB_ObjHead01 ="M1 " ;
   string IB_ObjHead02 ="M5  " ;     
   string IB_ObjHead03 ="M15 " ;
   string IB_ObjHead04 =" M30 " ;
   string IB_ObjHead05 ="H1  " ;     
   string IB_ObjHead06 ="H4  " ;
   string IB_ObjHead07 ="D1  " ;
   string IB_ObjHead08 ="W1  " ;
   string IB_ObjHead09 ="MN1" ;   
   
double open, close, high, low, high1, low1, ma, ma1, diff, diff1  ;  

//+------------------------------------------------------------------+
int init()
  {
   
   period       = Period() ;   
   tChartPeriod = TimeFrameToString(period) ;
   symbol       = Symbol() ;
   LabelTime    = symbol + tChartPeriod  ;  


   ObjHead01 = "FRACDColHead01"  ; 
   ObjHead02 = "FRACDColHead02"  ; 
   ObjHead03 = "FRACDColHead03"  ; 
   ObjHead04 = "FRACDColHead04"  ; 
   ObjHead05 = "FRACDColHead05"  ; 
   ObjHead06 = "FRACDColHead06"  ; 
   ObjHead07 = "FRACDColHead07"  ; 
   ObjHead08 = "FRACDColHead08"  ; 
   ObjHead09 = "FRACDColHead09"  ; 
         
   Obj0002 = "FRACDSignalM1t" ; 
   Obj0003 = "FRACDSignalM1" ;  
   Obj0004 = "FRACDSignalM5" ;  
   Obj0005 = "FRACDSignalM15" ;    
   Obj0006 = "FRACDSignalM30" ;    
   Obj0007 = "FRACDSignalM60" ;     
   Obj0008 = "FRACDSignalM240" ;   
   Obj0009 = "FRACDSignalM1440" ;   
   Obj0010 = "FRACDSignalW1" ;  
   Obj0011 = "FRACDSignalMN1" ;      
 
   ObDeleteObjectsByPrefix("FRACD");   
   
   
   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
 
   ObDeleteObjectsByPrefix("FRACD");          

   return(0);
  }
 
//+------------------------------------------------------------------+

int start()
{    
 
DoWork() ;

return(0);
} 
  
//+------------------------------------------------------------------+

void DoWork()
{ 

     
    if (Corner_of_Chart_RIGHT_TOP == true)
    { int Col01x = 170+Adjust_Side_to_side ;                 
      int Col01y = 28+Shift_UP_DN ;
    }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { Col01x = 159+Adjust_Side_to_side ;       
     Col01y = 24+Shift_UP_DN ;
    } 
    
   int ColAdj = -20 ; 
   int Col02x = Col01x + ColAdj ;   
   int Col03x = Col01x + ColAdj*2 ; 
   int Col04x = Col01x + ColAdj*3 ; 
   int Col05x = Col01x + ColAdj*4 ; 
   int Col06x = Col01x + ColAdj*5 ; 
   int Col07x = Col01x + ColAdj*6 ;    
   int Col08x = Col01x + ColAdj*7 ; 
   int Col09x = Col01x + ColAdj*8 ;     
   
   if ( Show_Heading) {        
   ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead01,IB_ObjHead01 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead02,IB_ObjHead02 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
       
   ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead03,IB_ObjHead03 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
 
   ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead04,IB_ObjHead04 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
   
   ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead05,IB_ObjHead05 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
            
   ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead06,IB_ObjHead06 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead07,IB_ObjHead07 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
         
   ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead08,IB_ObjHead08 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead09,IB_ObjHead09 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
       
} // Show_Heading

 //*******************   change for  your indicator ********************
 
    
    string M1_IB= "-",M5_IB= "-", M15_IB= "-", M30_IB= "-", H1_IB= "-", H4_IB= "-", D1_IB= "-",PRC1, W1_IB= "-", MN1_IB= "-";

    color  color_IBm1,color_IBm5,color_IBm15,color_IBm30,color_IBH1,color_IBH4,color_IBD1,color_IBW1,color_IBMN1;     
         

   //IB Signals

string symbol = Symbol() ;

 color_IBm1  = ColorIB( symbol, PERIOD_M1  ) ;
 
//Comment("m1 FRACTALS0=", DoubleToStr(FRACTALS0,Digits), "   FRACTALS1=", DoubleToStr(FRACTALS1,Digits) ) ; 
   
 color_IBm5  = ColorIB( symbol, PERIOD_M5  ) ;

//Comment( "m5 FRACTALS0 = " , DoubleToStr(FRACTALS0,5) ) ;  
 
 color_IBm15 = ColorIB( symbol, PERIOD_M15  ) ;
 

 
 color_IBm30 = ColorIB( symbol, PERIOD_M30  ) ;
 color_IBH1  = ColorIB( symbol, PERIOD_H1  ) ;
 

 
 
 color_IBH4  = ColorIB( symbol, PERIOD_H4  ) ;
 color_IBD1  = ColorIB( symbol, PERIOD_D1  ) ;
 color_IBW1  = ColorIB( symbol, PERIOD_W1  ) ;
 color_IBMN1 = ColorIB( symbol, PERIOD_MN1  ) ;

               
    
 //*******************          
    
    int Col00x = Col01x + 20 ;
    int Col00y = 50+Shift_UP_DN ;
    
    Col01y = 20+Shift_UP_DN ;

           ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0002,IndName, 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y);  // 50+Shift_UP_DN

      
           ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0003, M1_IB, 40, "Tahoma Narrow",  color_IBm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0004, M5_IB, 40, "Tahoma Narrow",  color_IBm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0005, M15_IB, 40, "Tahoma Narrow",  color_IBm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y); 
      

   ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0006, M30_IB, 40, "Tahoma Narrow",  color_IBm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y); 

    
           ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0007, H1_IB, 40, "Tahoma Narrow",  color_IBH1);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y); 

          
           ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0008, H4_IB, 40, "Tahoma Narrow",  color_IBH4);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y);

    
           ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0009, D1_IB, 40, "Tahoma Narrow",  color_IBD1);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y);
   
    
           ObjectCreate(Obj0010, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0010, W1_IB, 40, "Tahoma Narrow",  color_IBW1);
   ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y);   
   
   
           ObjectCreate(Obj0011, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0011, MN1_IB, 40, "Tahoma Narrow",  color_IBMN1);
   ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y); 
     
   WindowRedraw() ;   
   

   
   return(0);
}


  

color ColorIB( string symbol, int period )  
{

color MA_color;
 
close = iClose(symbol,period,0);   
    
FRACTALS0 = iCustom(symbol, period, "fractal_dimensions",21,0,0.55,0,0);  
//FRACTALS1 = iCustom(symbol, period, "FRACDtal_dimension",21,0,0.55,0,1);  
  
 
 
MA_color = DimGray ;  

if( FRACTALS0 > 0.55 ) { MA_color = Green ; }
if( FRACTALS0 < 0.30 ) { MA_color = Red ; }
 
return( MA_color ) ;   
                                    
} // end DoWork
 
//+------------------------------------------------------------------+
 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
 